]> git.saurik.com Git - apt.git/blame - test/integration/framework
merged from david
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
682a3bf7
DK
4if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
5 expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
6 CERROR="\e[1;31m" # red
7 CWARNING="\e[1;33m" # yellow
8 CMSG="\e[1;32m" # green
9 CINFO="\e[1;96m" # light blue
10 CDEBUG="\e[1;94m" # blue
11 CNORMAL="\e[0;39m" # default system console color
12 CDONE="\e[1;32m" # green
13 CPASS="\e[1;32m" # green
14 CFAIL="\e[1;31m" # red
15 CCMD="\e[1;35m" # pink
16fi
8d876415
DK
17
18msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
19msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
20msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
21msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
22msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
23msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
24msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
25msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
26msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
27msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
2a2a7ef4
DK
28msgtest() {
29 while [ -n "$1" ]; do
30 echo -n "${CINFO}$1${CCMD} " >&2;
31 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
d73840dc
DK
32 shift
33 if [ -n "$1" ]; then shift; else break; fi
2a2a7ef4
DK
34 done
35 echo -n "…${CNORMAL} " >&2;
36}
8d876415
DK
37msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
38msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
39msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
40
41# enable / disable Debugging
fc89263e
DK
42MSGLEVEL=${MSGLEVEL:-3}
43if [ $MSGLEVEL -le 0 ]; then
44 msgdie() { true; }
45fi
46if [ $MSGLEVEL -le 1 ]; then
47 msgwarn() { true; }
48 msgnwarn() { true; }
49fi
50if [ $MSGLEVEL -le 2 ]; then
51 msgmsg() { true; }
52 msgnmsg() { true; }
39cc8228
DK
53 msgtest() { true; }
54 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
55 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
682a3bf7
DK
56 if [ -n "$CFAIL" ]; then
57 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
58 else
59 msgfail() { echo -n " ###FAILED###" >&2; }
60 fi
fc89263e
DK
61fi
62if [ $MSGLEVEL -le 3 ]; then
63 msginfo() { true; }
64 msgninfo() { true; }
65fi
66if [ $MSGLEVEL -le 4 ]; then
67 msgdebug() { true; }
68 msgndebug() { true; }
69fi
70msgdone() {
71 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
72 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
73 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
74 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
75 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
76 true;
77 else
78 echo "${CDONE}DONE${CNORMAL}" >&2;
79 fi
80}
8d876415
DK
81
82runapt() {
83 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
84 if [ -f ./aptconfig.conf ]; then
85 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
86 elif [ -f ../aptconfig.conf ]; then
87 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
88 else
89 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
90 fi
8d876415
DK
91}
92aptconfig() { runapt apt-config $*; }
93aptcache() { runapt apt-cache $*; }
94aptget() { runapt apt-get $*; }
95aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 96aptkey() { runapt apt-key $*; }
ec7f904e 97aptmark() { runapt apt-mark $*; }
158fda31
DK
98dpkg() {
99 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
100}
b6b5a542
DK
101aptitude() {
102 if [ -f ./aptconfig.conf ]; then
103 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
104 elif [ -f ../aptconfig.conf ]; then
105 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
106 else
107 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
108 fi
109}
3fa950f1
DK
110gdb() {
111 echo "gdb: run »$*«"
112 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
113}
8d876415 114
b720d0bd
DK
115addtrap() {
116 CURRENTTRAP="$CURRENTTRAP $1"
a7e052ea 117 trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 118}
8d876415
DK
119
120setupenvironment() {
75954ae2 121 TMPWORKINGDIRECTORY=$(mktemp -d)
53ea1b56 122 TESTDIRECTORY=$(readlink -f $(dirname $0))
3cbbda3c 123 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
53ea1b56 124 BUILDDIRECTORY="${TESTDIRECTORY}/../../build/bin"
8d876415
DK
125 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
126 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 127 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 128 cd $TMPWORKINGDIRECTORY
cd725954 129 mkdir rootdir aptarchive keys
8d876415 130 cd rootdir
b29c3712
DK
131 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
132 mkdir -p var/cache var/lib var/log
cffea9af 133 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 134 touch var/lib/dpkg/available
8d876415
DK
135 mkdir -p usr/lib/apt
136 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
137 cd ..
2c6baa5a 138 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
53ea1b56
DK
139 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
140 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 141 fi
4a4ea26c 142 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
53ea1b56
DK
143 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
144 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 145 fi
53ea1b56 146 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
cd725954 147 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 148 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 149 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
150 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
151 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 152 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
153 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
154 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
155 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
156 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
157 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
c204d148 158 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
53ea1b56
DK
159 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
160 fi
cffea9af 161 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 162 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415 163 export LC_ALL=C
7f52cf7b 164 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
8d876415
DK
165 msgdone "info"
166}
167
ea65d079
DK
168getarchitecture() {
169 if [ "$1" = "native" -o -z "$1" ]; then
170 eval `aptconfig shell ARCH APT::Architecture`
171 if [ -n "$ARCH" ]; then
172 echo $ARCH
173 else
5834d7a1 174 dpkg --print-architecture
ea65d079
DK
175 fi
176 else
177 echo $1
178 fi
179}
180
53ea1b56
DK
181getarchitectures() {
182 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
183}
184
8d876415
DK
185configarchitecture() {
186 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
234675b7 187 rm -f $CONFFILE
ea65d079 188 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
8d876415
DK
189 shift
190 while [ -n "$1" ]; do
ea65d079 191 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
8d876415
DK
192 shift
193 done
53ea1b56
DK
194 configdpkg
195}
196
197configdpkg() {
198 if [ ! -e rootdir/var/lib/dpkg/status ]; then
199 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
200 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
201 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
202 else
203 echo -n > rootdir/var/lib/dpkg/status
204 fi
205 fi
c204d148 206 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
53ea1b56
DK
207 local ARCHS="$(getarchitectures)"
208 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
209 DPKGARCH="$(dpkg --print-architecture)"
210 for ARCH in ${ARCHS}; do
211 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
212 done
213 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
214 # dpkg doesn't really check the version as long as it is fully installed,
215 # but just to be sure we choose one above the required version
216 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
217 fi
218 fi
219 fi
8d876415
DK
220}
221
75954ae2 222setupsimplenativepackage() {
ce9864a8
DK
223 local NAME="$1"
224 local ARCH="$2"
225 local VERSION="$3"
226 local RELEASE="${4:-unstable}"
227 local DEPENDENCIES="$5"
228 local DESCRIPTION="$6"
b7899b00
DK
229 local SECTION="${7:-others}"
230 local DISTSECTION
231 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
232 DISTSECTION="main"
233 else
234 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
235 fi
ce9864a8
DK
236 local BUILDDIR=incoming/${NAME}-${VERSION}
237 mkdir -p ${BUILDDIR}/debian/source
238 cd ${BUILDDIR}
239 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
240 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
241 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
242
243 * Initial release
244
b7899b00
DK
245 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
246 test -e debian/control || echo "Source: $NAME
247Section: $SECTION
ce9864a8
DK
248Priority: optional
249Maintainer: Joe Sixpack <joe@example.org>
250Build-Depends: debhelper (>= 7)
251Standards-Version: 3.9.1
252
875bcb36
DK
253Package: $NAME" > debian/control
254 if [ "$ARCH" = 'all' ]; then
255 echo "Architecture: all" >> debian/control
256 else
257 echo "Architecture: any" >> debian/control
258 fi
ce9864a8
DK
259 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
260 if [ -z "$DESCRIPTION" ]; then
261 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
262 If you find such a package installed on your system,
263 YOU did something horribly wrong! They are autogenerated
264 und used only by testcases for APT and surf no other propose…" >> debian/control
265 else
266 echo "Description: $DESCRIPTION" >> debian/control
267 fi
b7899b00
DK
268 test -e debian/compat || echo "7" > debian/compat
269 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 270 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
271 cd - > /dev/null
272}
273
274buildsimplenativepackage() {
275 local NAME="$1"
276 local ARCH="$2"
277 local VERSION="$3"
278 local RELEASE="${4:-unstable}"
279 local DEPENDENCIES="$5"
280 local DESCRIPTION="$6"
281 local SECTION="${7:-others}"
d67004e0 282 local PRIORITY="${8:-optional}"
75954ae2
DK
283 local DISTSECTION
284 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
285 DISTSECTION="main"
286 else
287 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
288 fi
5a635ee4 289 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 290
18331adf 291 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
292 mkdir -p $BUILDDIR/debian/source
293 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
294 echo "#!/bin/sh
295echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
296
297 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
298 echo "$NAME ($VERSION) $RELEASE; urgency=low
299
300 * Initial release
301
302 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
303 echo "Source: $NAME
304Section: $SECTION
d67004e0 305Priority: $PRIORITY
b761356f
DK
306Maintainer: Joe Sixpack <joe@example.org>
307Standards-Version: 3.9.1
308
875bcb36
DK
309Package: $NAME" > ${BUILDDIR}/debian/control
310 if [ "$ARCH" = 'all' ]; then
311 echo "Architecture: all" >> ${BUILDDIR}/debian/control
312 else
313 echo "Architecture: any" >> ${BUILDDIR}/debian/control
314 fi
b761356f
DK
315 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
316 if [ -z "$DESCRIPTION" ]; then
317 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
318 If you find such a package installed on your system,
319 YOU did something horribly wrong! They are autogenerated
320 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
321 else
322 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
323 fi
324 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
325 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 326 for SRC in $SRCS; do
5a635ee4 327 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 328 done
84aa13f4 329
ea65d079 330 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
84aa13f4
DK
331 rm -rf ${BUILDDIR}/debian/tmp
332 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
333 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
334 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
335 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
336 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
337
338 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
339 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
340 done
341
13845042
DK
342 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
343 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
344 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 345 rm -rf "${BUILDDIR}"
b761356f 346 msgdone "info"
75954ae2
DK
347}
348
349buildpackage() {
350 local BUILDDIR=$1
351 local RELEASE=$2
352 local SECTION=$3
ea65d079 353 local ARCH=$(getarchitecture $4)
75954ae2
DK
354 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
355 cd $BUILDDIR
356 if [ "$ARCH" = "all" ]; then
357 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
358 fi
b7899b00
DK
359 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
360 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 361 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 362 cd - > /dev/null
b7899b00 363 for PKG in $PKGS; do
75954ae2 364 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
365 done
366 for SRC in $SRCS; do
75954ae2 367 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 368 done
cffea9af 369 msgdone "info"
ce9864a8
DK
370}
371
372buildaptarchive() {
ce9864a8
DK
373 if [ -d incoming ]; then
374 buildaptarchivefromincoming $*
375 else
376 buildaptarchivefromfiles $*
377 fi
378}
379
380createaptftparchiveconfig() {
381 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
382 if [ -z "$ARCHS" ]; then
383 # the pool is empty, so we will operate on faked packages - let us use the configured archs
53ea1b56 384 ARCHS="$(getarchitectures)"
158fda31 385 fi
ce9864a8
DK
386 echo -n 'Dir {
387 ArchiveDir "' >> ftparchive.conf
388 echo -n $(readlink -f .) >> ftparchive.conf
389 echo -n '";
390 CacheDir "' >> ftparchive.conf
391 echo -n $(readlink -f ..) >> ftparchive.conf
392 echo -n '";
b7899b00
DK
393 FileListDir "' >> ftparchive.conf
394 echo -n $(readlink -f pool/) >> ftparchive.conf
395 echo -n '";
396};
397Default {
bc33e0f0
DK
398 Packages::Compress ". gzip bzip2 lzma xz";
399 Sources::Compress ". gzip bzip2 lzma xz";
400 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 401 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 402 LongDescription "false";
ce9864a8
DK
403};
404TreeDefault {
405 Directory "pool/";
406 SrcDirectory "pool/";
407};
408APT {
409 FTPArchive {
410 Release {
411 Origin "joesixpack";
412 Label "apttestcases";
413 Suite "unstable";
414 Description "repository with dummy packages";
415 Architectures "' >> ftparchive.conf
416 echo -n "$ARCHS" >> ftparchive.conf
417 echo 'source";
418 };
419 };
420};' >> ftparchive.conf
b7899b00
DK
421 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
422 echo -n 'tree "dists/' >> ftparchive.conf
423 echo -n "$DIST" >> ftparchive.conf
424 echo -n '" {
ce9864a8
DK
425 Architectures "' >> ftparchive.conf
426 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
427 echo -n 'source";
428 FileList "' >> ftparchive.conf
429 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
430 echo -n '";
431 SourceFileList "' >> ftparchive.conf
432 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
433 echo -n '";
434 Sections "' >> ftparchive.conf
435 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
436 echo '";
ce9864a8 437};' >> ftparchive.conf
b7899b00 438 done
ce9864a8
DK
439}
440
441buildaptftparchivedirectorystructure() {
b7899b00
DK
442 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
443 for DIST in $DISTS; do
444 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
445 for SECTION in $SECTIONS; do
446 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
447 for ARCH in $ARCHS; do
448 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
449 done
450 mkdir -p dists/${DIST}/${SECTION}/source
451 mkdir -p dists/${DIST}/${SECTION}/i18n
452 done
ce9864a8 453 done
ce9864a8
DK
454}
455
9b78cda6
DK
456insertpackage() {
457 local RELEASE="$1"
458 local NAME="$2"
459 local ARCH="$3"
460 local VERSION="$4"
461 local DEPENDENCIES="$5"
d67004e0
DK
462 local PRIORITY="${6:-optional}"
463 local ARCHS=""
ea65d079 464 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
d67004e0 465 if [ "$arch" = "all" ]; then
53ea1b56 466 ARCHS="$(getarchitectures)"
d67004e0
DK
467 else
468 ARCHS="$arch"
469 fi
470 for BUILDARCH in $ARCHS; do
471 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
472 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
473 touch aptarchive/dists/${RELEASE}/main/source/Sources
474 local FILE="${PPATH}/Packages"
475 echo "Package: $NAME
476Priority: $PRIORITY
9b78cda6 477Section: other
2c085486 478Installed-Size: 42
9b78cda6 479Maintainer: Joe Sixpack <joe@example.org>
d67004e0 480Architecture: $arch
2c085486 481Version: $VERSION
d67004e0
DK
482Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
483 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
484 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
9b78cda6
DK
485 If you find such a package installed on your system,
486 YOU did something horribly wrong! They are autogenerated
487 und used only by testcases for APT and surf no other propose…
488" >> $FILE
d67004e0 489 done
9b78cda6
DK
490 done
491}
492
234675b7
DK
493insertsource() {
494 local RELEASE="$1"
495 local NAME="$2"
496 local ARCH="$3"
497 local VERSION="$4"
498 local DEPENDENCIES="$5"
499 local ARCHS=""
500 local SPATH="aptarchive/dists/${RELEASE}/main/source"
501 mkdir -p $SPATH
502 local FILE="${SPATH}/Sources"
503 echo "Package: $NAME
504Binary: $NAME
505Version: $VERSION
506Maintainer: Joe Sixpack <joe@example.org>
507Architecture: $ARCH" >> $FILE
508 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
509 echo "Files:
510 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
511 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz" >> $FILE
512}
513
dfc2b1be
DK
514insertinstalledpackage() {
515 local NAME="$1"
516 local ARCH="$2"
517 local VERSION="$3"
518 local DEPENDENCIES="$4"
d67004e0 519 local PRIORITY="${5:-optional}"
53ea1b56
DK
520 local FILE='rootdir/var/lib/dpkg/status'
521 local INFO='rootdir/var/lib/dpkg/info'
ea65d079 522 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
d67004e0 523 echo "Package: $NAME
dfc2b1be 524Status: install ok installed
d67004e0 525Priority: $PRIORITY
dfc2b1be
DK
526Section: other
527Installed-Size: 42
528Maintainer: Joe Sixpack <joe@example.org>
d67004e0 529Architecture: $arch
dfc2b1be 530Version: $VERSION" >> $FILE
d67004e0
DK
531 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
532 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
dfc2b1be
DK
533 If you find such a package installed on your system,
534 YOU did something horribly wrong! They are autogenerated
535 und used only by testcases for APT and surf no other propose…
536" >> $FILE
53ea1b56
DK
537 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
538 echo -n > ${INFO}/${NAME}:${arch}.list
539 else
540 echo -n > ${INFO}/${NAME}.list
541 fi
d67004e0 542 done
dfc2b1be
DK
543}
544
545
ce9864a8 546buildaptarchivefromincoming() {
3cbbda3c 547 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
548 cd aptarchive
549 [ -e pool ] || ln -s ../incoming pool
550 [ -e ftparchive.conf ] || createaptftparchiveconfig
551 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 552 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 553 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
554 cd - > /dev/null
555 msgdone "info"
9b78cda6 556 generatereleasefiles
ce9864a8
DK
557}
558
559buildaptarchivefromfiles() {
3cbbda3c 560 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
561 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
562 msgninfo "\t${line} file… "
563 cat ${line} | gzip > ${line}.gz
564 cat ${line} | bzip2 > ${line}.bz2
8bcbc694 565 cat ${line} | xz --format=lzma > ${line}.lzma
b7080ced 566 cat ${line} | xz > ${line}.xz
8d876415 567 msgdone "info"
9b78cda6
DK
568 done
569 generatereleasefiles
570}
571
a3bbbab7
DK
572# can be overridden by testcases for their pleasure
573getcodenamefromsuite() { echo -n "$1"; }
574getreleaseversionfromsuite() { true; }
718f797c 575getlabelfromsuite() { true; }
a3bbbab7 576
9b78cda6 577generatereleasefiles() {
884a4c0a
DK
578 # $1 is the Date header and $2 is the ValidUntil header to be set
579 # both should be given in notation date/touch can understand
9b78cda6
DK
580 msgninfo "\tGenerate Release files… "
581 if [ -e aptarchive/dists ]; then
582 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
583 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
584 local CODENAME="$(getcodenamefromsuite $SUITE)"
585 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 586 local LABEL="$(getlabelfromsuite $SUITE)"
884a4c0a 587 if [ -n "$VERSION" ]; then
718f797c
DK
588 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
589 fi
590 if [ -n "$LABEL" ]; then
591 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 592 fi
884a4c0a
DK
593 aptftparchive -qq release $dir \
594 -o APT::FTPArchive::Release::Suite="${SUITE}" \
595 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 596 ${LABEL} \
884a4c0a
DK
597 ${VERSION} \
598 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
a3bbbab7 599 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
600 sed -i '/^Date: / a\
601NotAutomatic: yes' $dir/Release
602 fi
884a4c0a
DK
603 if [ -n "$1" -a "$1" != "now" ]; then
604 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
605 fi
606 if [ -n "$2" ]; then
607 sed -i "/^Date: / a\
608Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
609 fi
9b78cda6
DK
610 done
611 else
612 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 613 fi
884a4c0a 614 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911
DK
615 for release in $(find ./aptarchive -name 'Release'); do
616 touch -d "$1" $release
617 done
8d876415 618 fi
b7899b00 619 msgdone "info"
8d876415
DK
620}
621
b7899b00
DK
622setupdistsaptarchive() {
623 local APTARCHIVE=$(readlink -f ./aptarchive)
624 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
625 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
626 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
627 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
628 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
629 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
630 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
631 msgdone "info"
632 done
633}
634
635setupflataptarchive() {
ce9864a8 636 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
637 if [ -f ${APTARCHIVE}/Packages ]; then
638 msgninfo "\tadd deb sources.list line… "
639 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
640 msgdone "info"
641 else
642 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
643 fi
644 if [ -f ${APTARCHIVE}/Sources ]; then
645 msgninfo "\tadd deb-src sources.list line… "
646 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
647 msgdone "info"
648 else
649 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
650 fi
b7899b00
DK
651}
652
653setupaptarchive() {
654 buildaptarchive
655 if [ -e aptarchive/dists ]; then
656 setupdistsaptarchive
657 else
658 setupflataptarchive
659 fi
f213b6ea 660 signreleasefiles
cd725954 661 msgninfo "\tSync APT's cache with the archive… "
8d876415 662 aptget update -qq
cd725954 663 msgdone "info"
8d876415
DK
664}
665
f213b6ea
DK
666signreleasefiles() {
667 local SIGNER="${1:-Joe Sixpack}"
668 msgninfo "\tSign archive with $SIGNER key… "
669 local SECKEYS=""
670 for KEY in $(find keys/ -name '*.sec'); do
671 SECKEYS="$SECKEYS --secret-keyring $KEY"
672 done
673 local PUBKEYS=""
674 for KEY in $(find keys/ -name '*.pub'); do
675 PUBKEYS="$PUBKEYS --keyring $KEY"
676 done
677 for RELEASE in $(find aptarchive/ -name Release); do
678 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 679 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
680 done
681 msgdone "info"
682}
683
684changetowebserver() {
685 if which weborf > /dev/null; then
686 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 687 addtrap "kill $!;"
6e7d39d0
DK
688 elif which gatling > /dev/null; then
689 cd aptarchive
690 gatling -p 8080 -F -S 2>&1 > /dev/null &
691 addtrap "kill $!;"
692 cd - > /dev/null
c5bcc607
DK
693 elif which lighttpd > /dev/null; then
694 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
695server.port = 8080
696server.stat-cache-engine = \"disable\"" > lighttpd.conf
697 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
698 lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
699 addtrap "kill $!;"
700 else
701 msgdie 'You have to install weborf or lighttpd first'
702 return 1
f213b6ea 703 fi
c5bcc607
DK
704 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
705 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
706 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
707 done
708 return 0
f213b6ea
DK
709}
710
711checkdiff() {
8d876415
DK
712 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
713 if [ -n "$DIFFTEXT" ]; then
714 echo
715 echo "$DIFFTEXT"
716 return 1
717 else
718 return 0
719 fi
720}
721
75954ae2
DK
722testfileequal() {
723 local FILE="$1"
724 shift
725 msgtest "Test for correctness of file" "$FILE"
726 if [ -z "$*" ]; then
f213b6ea 727 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 728 else
f213b6ea 729 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
730 fi
731}
732
8d876415
DK
733testequal() {
734 local COMPAREFILE=$(mktemp)
b720d0bd 735 addtrap "rm $COMPAREFILE;"
8d876415
DK
736 echo "$1" > $COMPAREFILE
737 shift
738 msgtest "Test for equality of" "$*"
f213b6ea 739 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
740}
741
685625bd
DK
742testequalor2() {
743 local COMPAREFILE1=$(mktemp)
744 local COMPAREFILE2=$(mktemp)
745 local COMPAREAGAINST=$(mktemp)
b720d0bd 746 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
747 echo "$1" > $COMPAREFILE1
748 echo "$2" > $COMPAREFILE2
749 shift 2
750 msgtest "Test for equality OR of" "$*"
751 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
752 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
753 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
754 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
755 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
756 msgfail )
757}
758
8d876415 759testshowvirtual() {
edc0ef10 760 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
761 local PACKAGE="$1"
762 shift
763 while [ -n "$1" ]; do
764 VIRTUAL="${VIRTUAL}
edc0ef10 765N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
766 PACKAGE="${PACKAGE} $1"
767 shift
768 done
769 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
770 VIRTUAL="${VIRTUAL}
4bec02c2 771N: No packages found"
8d876415 772 local COMPAREFILE=$(mktemp)
b720d0bd 773 addtrap "rm $COMPAREFILE;"
ea65d079 774 local ARCH="$(getarchitecture 'native')"
8d876415 775 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 776 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
777}
778
779testnopackage() {
780 msgtest "Test for non-existent packages" "apt-cache show $*"
781 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
782 if [ -n "$SHOWPKG" ]; then
783 echo
784 echo "$SHOWPKG"
785 msgfail
786 return 1
787 fi
788 msgpass
789}
01a6e24c
DK
790
791testdpkginstalled() {
792 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
793 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
794 if [ "$PKGS" != $# ]; then
01a6e24c
DK
795 echo $PKGS
796 dpkg -l $* | grep '^[a-z]'
797 msgfail
798 return 1
799 fi
800 msgpass
801}
802
5cf733e1
DK
803testdpkgnotinstalled() {
804 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 805 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
806 if [ "$PKGS" != 0 ]; then
807 echo
808 dpkg -l $* | grep '^[a-z]'
809 msgfail
810 return 1
811 fi
812 msgpass
813}
ec7f904e
DK
814
815testmarkedauto() {
816 local COMPAREFILE=$(mktemp)
817 addtrap "rm $COMPAREFILE;"
818 if [ -n "$1" ]; then
819 msgtest 'Test for correctly marked as auto-installed' "$*"
820 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
821 else
822 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 823 echo -n > $COMPAREFILE
ec7f904e
DK
824 fi
825 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
826}
89a1aa5d
DK
827
828pause() {
829 echo "STOPPED execution. Press enter to continue"
830 local IGNORE
831 read IGNORE
832}